#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rsbac/types.h>
#include <rsbac/aci_data_structures.h>
#include <rsbac/getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>
#include <rsbac/helpers.h>

int main(int argc, char ** argv)
{
  int res = 0;
  char tmp1[80];
  enum rsbac_target_t target;
  
  if (argc == 3)
    {
      target = get_target_nr(argv[1]);
      res = rsbac_remove_target_n(target, argv[2]);
      if(res)
        {
          if((res > -RSBAC_EPERM) || (res < -RSBAC_EDECISIONMISMATCH))
            {
              fprintf(stderr, "%s: Error: %s\n", argv[0], strerror(-res));
            }
          else
            {
              get_error_name(tmp1,res);
              fprintf(stderr, "%s: error: %s\n", argv[0], tmp1);
            }
          exit(1);
        }
      exit(0);
    }
  else
    {
      printf("%s (RSBAC %s)\n***\n", argv[0], VERSION);
      printf("Use: %s target-type file/dirname\n", argv[0]);  
      printf("- target-type = FILE, DIR or DEV,\n");
    }
  exit(1);
}
