#include <stdio.h>
#include <stdlib.h>
#include <rsbac/types.h>
#include <rsbac/rc_data_structures.h>
#include <rsbac/getname.h>
#include <rsbac/rc_getname.h>
#include <rsbac/syscalls.h>
#include <rsbac/error.h>
#include <rsbac/helpers.h>

int main(int argc, char ** argv)
{
  int res = 0;
  int comp_type;
  enum rsbac_adf_request_t request;
  char tmp1[80],tmp2[120];
  int j,i;
  enum rsbac_rc_target_t target;
  union rsbac_rc_target_id_t tid;
  enum rsbac_rc_item_t item;
  union rsbac_rc_item_value_t value;
  char * progname = argv[0];
  int role_entry_item_list[RSBAC_RC_NR_ROLE_ENTRY_ITEMS] = RSBAC_RC_ROLE_ENTRY_ITEM_LIST;
  int type_entry_item_list[RSBAC_RC_NR_TYPE_ENTRY_ITEMS] = RSBAC_RC_TYPE_ENTRY_ITEM_LIST;
  boolean show_unused = FALSE;
  boolean show_names = FALSE;
  
  switch(argc)
    {
      case 2:
        if(   !strcmp(argv[1],"list_roles")
           || !strcmp(argv[1],"list_used_roles")
           || !strcmp(argv[1],"list_role_nr")
           || !strcmp(argv[1],"list_used_role_nr")
          )
          {
            target = RT_ROLE;
            item = RI_name;
            if(   !strcmp(argv[1],"list_roles")
               || !strcmp(argv[1],"list_role_nr")
              )
              show_unused = TRUE;
            if(   !strcmp(argv[1],"list_roles")
               || !strcmp(argv[1],"list_used_roles")
              )
              show_names = TRUE;
            for(j=0; j<RSBAC_RC_NR_ROLES; j++)
              {
                tid.role = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                if(!res)
                  {
                    if(value.name[0] == 0)
                      {
                        if(show_unused)
                          strcpy(value.name, "(unused)");
                        else
                          continue;
                      }
                    else
                      for(i=0; i<strlen(value.name); i++)
                        if(value.name[i] == ' ')
                          value.name[i] = '_';
                    if(show_names)
                      printf("%02i %s\n", j, value.name);
                    else
                      printf("%02i\n", j);
                  }
                else
                  break;
              }
            exit(0);
          }
        if(   !strcmp(argv[1],"list_fd_types")
           || !strcmp(argv[1],"list_used_fd_types")
           || !strcmp(argv[1],"list_fd_type_nr")
           || !strcmp(argv[1],"list_used_fd_type_nr")
          )
          {
            target = RT_TYPE;
            item = RI_type_fd_name;
            if(   !strcmp(argv[1],"list_fd_types")
               || !strcmp(argv[1],"list_fd_type_nr"))
              show_unused = TRUE;
            if(   !strcmp(argv[1],"list_fd_types")
               || !strcmp(argv[1],"list_used_fd_types")
              )
              show_names = TRUE;
            for(j=0; j<RSBAC_RC_NR_TYPES; j++)
              {
                tid.type = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                error_exit(res);
                if(value.name[0] == 0)
                  {
                    if(show_unused)
                      strcpy(value.name, "(unused)");
                    else
                      continue;
                  }
                else
                  for(i=0; i<strlen(value.name); i++)
                    if(value.name[i] == ' ')
                      value.name[i] = '_';
                if(show_names)
                  printf("%02i %s\n", j, value.name);
                else
                  printf("%02i\n", j);
              }
            exit(0);
          }
        if(   !strcmp(argv[1],"list_dev_types")
           || !strcmp(argv[1],"list_used_dev_types")
           || !strcmp(argv[1],"list_dev_type_nr")
           || !strcmp(argv[1],"list_used_dev_type_nr")
          )
          {
            target = RT_TYPE;
            item = RI_type_dev_name;
            if(   !strcmp(argv[1],"list_dev_types")
               || !strcmp(argv[1],"list_dev_type_nr"))
              show_unused = TRUE;
            if(   !strcmp(argv[1],"list_dev_types")
               || !strcmp(argv[1],"list_used_dev_types")
              )
              show_names = TRUE;
            for(j=0; j<RSBAC_RC_NR_TYPES; j++)
              {
                tid.type = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                error_exit(res);
                if(value.name[0] == 0)
                  {
                    if(show_unused)
                      strcpy(value.name, "(unused)");
                    else
                      continue;
                  }
                else
                  for(i=0; i<strlen(value.name); i++)
                    if(value.name[i] == ' ')
                      value.name[i] = '_';
                if(show_names)
                  printf("%02i %s\n", j, value.name);
                else
                  printf("%02i\n", j);
              }
            exit(0);
          }
        if(   !strcmp(argv[1],"list_process_types")
           || !strcmp(argv[1],"list_used_process_types")
           || !strcmp(argv[1],"list_process_type_nr")
           || !strcmp(argv[1],"list_used_process_type_nr")
          )
          {
            target = RT_TYPE;
            item = RI_type_process_name;
            if(   !strcmp(argv[1],"list_process_types")
               || !strcmp(argv[1],"list_process_type_nr"))
              show_unused = TRUE;
            if(   !strcmp(argv[1],"list_process_types")
               || !strcmp(argv[1],"list_used_process_types")
              )
              show_names = TRUE;
            for(j=0; j<RSBAC_RC_NR_TYPES; j++)
              {
                tid.type = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                error_exit(res);
                if(value.name[0] == 0)
                  {
                    if(show_unused)
                      strcpy(value.name, "(unused)");
                    else
                      continue;
                  }
                else
                  for(i=0; i<strlen(value.name); i++)
                    if(value.name[i] == ' ')
                      value.name[i] = '_';
                if(show_names)
                  printf("%02i %s\n", j, value.name);
                else
                  printf("%02i\n", j);
              }
            exit(0);
          }
        if(   !strcmp(argv[1],"list_ipc_types")
           || !strcmp(argv[1],"list_used_ipc_types")
           || !strcmp(argv[1],"list_ipc_type_nr")
           || !strcmp(argv[1],"list_used_ipc_type_nr")
          )
          {
            target = RT_TYPE;
            item = RI_type_ipc_name;
            if(   !strcmp(argv[1],"list_ipc_types")
               || !strcmp(argv[1],"list_ipc_type_nr"))
              show_unused = TRUE;
            if(   !strcmp(argv[1],"list_ipc_types")
               || !strcmp(argv[1],"list_used_ipc_types")
              )
              show_names = TRUE;
            for(j=0; j<RSBAC_RC_NR_TYPES; j++)
              {
                tid.type = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                error_exit(res);
                if(value.name[0] == 0)
                  {
                    if(show_unused)
                      strcpy(value.name, "(unused)");
                    else
                      continue;
                  }
                else
                  for(i=0; i<strlen(value.name); i++)
                    if(value.name[i] == ' ')
                      value.name[i] = '_';
                if(show_names)
                  printf("%02i %s\n", j, value.name);
                else
                  printf("%02i\n", j);
              }
            exit(0);
          }
        if(   !strcmp(argv[1],"list_scd_types")
           || !strcmp(argv[1],"list_used_scd_types")
           || !strcmp(argv[1],"list_scd_type_nr")
           || !strcmp(argv[1],"list_used_scd_type_nr")
          )
          {
            target = RT_TYPE;
            item = RI_type_scd_name;
            if(   !strcmp(argv[1],"list_scd_types")
               || !strcmp(argv[1],"list_scd_type_nr"))
              show_unused = TRUE;
            if(   !strcmp(argv[1],"list_scd_types")
               || !strcmp(argv[1],"list_used_scd_types")
              )
              show_names = TRUE;
            for(j=0; j<ST_none; j++)
              {
                tid.type = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                error_exit(res);
                if(value.name[0] == 0)
                  {
                    if(show_unused)
                      strcpy(value.name, "(unused)");
                    else
                      continue;
                  }
                else
                  for(i=0; i<strlen(value.name); i++)
                    if(value.name[i] == ' ')
                      value.name[i] = '_';
                if(show_names)
                  printf("%02i %s\n", j, value.name);
                else
                  printf("%02i\n", j);
              }
            for(j=RST_min; j<RST_none; j++)
              {
                tid.type = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                error_exit(res);
                if(value.name[0] == 0)
                  {
                    if(show_unused)
                      strcpy(value.name, "(unused)");
                    else
                      continue;
                  }
                else
                  for(i=0; i<strlen(value.name); i++)
                    if(value.name[i] == ' ')
                      value.name[i] = '_';
                if(show_names)
                  printf("%02i %s\n", j, value.name);
                else
                  printf("%02i\n", j);
              }
            exit(0);
          }
        if(   !strcmp(argv[1],"list_fd_requests")
           || !strcmp(argv[1],"list_dev_requests")
           || !strcmp(argv[1],"list_ipc_requests")
           || !strcmp(argv[1],"list_scd_requests")
           || !strcmp(argv[1],"list_user_requests")
           || !strcmp(argv[1],"list_process_requests")
           || !strcmp(argv[1],"list_none_requests")
           || !strcmp(argv[1],"list_all_requests")
          )
          {
            rsbac_rc_request_vector_t request_mask;

            switch(argv[1][5])
              {
                case 'f':
                  request_mask=RSBAC_FD_REQUEST_VECTOR;
                  break;
                case 'd':
                  request_mask=RSBAC_DEV_REQUEST_VECTOR;
                  break;
                case 'i':
                  request_mask=RSBAC_IPC_REQUEST_VECTOR;
                  break;
                case 's':
                  request_mask=RSBAC_SCD_REQUEST_VECTOR | RSBAC_SYSTEM_REQUEST_VECTOR;
                  break;
                case 'u':
                  request_mask=RSBAC_USER_REQUEST_VECTOR;
                  break;
                case 'p':
                  request_mask=RSBAC_PROCESS_REQUEST_VECTOR;
                  break;
                case 'n':
                  request_mask=RSBAC_NONE_REQUEST_VECTOR;
                  break;
                case 'a':
                  request_mask=RSBAC_ALL_REQUEST_VECTOR;
                  break;
                default:
                  fprintf(stderr, "%s: Internal request list error, param %s!\n",
                          progname,
                          argv[1]);
                  exit(1);
              }
            for(j=0; j<R_NONE; j++)
              {
                if(request_mask & ((rsbac_rc_request_vector_t) 1 << j))
                  printf("%s\n", get_request_name(tmp1,j));
              }
            exit(0);
          }
        if(!strcmp(argv[1],"list_unused_role_nr"))
          {
            target = RT_ROLE;
            item = RI_name;
            for(j=0; j<RSBAC_RC_NR_ROLES; j++)
              {
                tid.role = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                if(!res)
                  {
                    if(value.name[0] == 0)
                      {
                        printf("%02i\n", j);
                      }
                  }
                else
                  break;
              }
            exit(0);
          }
        if(   !strcmp(argv[1],"list_unused_fd_type_nr")
           || !strcmp(argv[1],"list_unused_dev_type_nr")
           || !strcmp(argv[1],"list_unused_ipc_type_nr")
           || !strcmp(argv[1],"list_unused_process_type_nr")
          )
          {
            target = RT_TYPE;
            switch(argv[1][12])
              {
                case 'f':
                  item = RI_type_fd_name;
                  break;
                case 'd':
                  item = RI_type_dev_name;
                  break;
                case 'i':
                  item = RI_type_ipc_name;
                  break;
                case 'p':
                  item = RI_type_process_name;
                  break;
                default:
                  fprintf(stderr, "%s: Internal unused list error, param %s!\n",
                          progname,
                          argv[1]);
                  exit(1);
              }
            for(j=0; j<RSBAC_RC_NR_TYPES; j++)
              {
                tid.type = j;
                value.dummy = -1;
                res = rsbac_rc_get_item(target, &tid, item, &value);
                error_exit(res);
                if(value.name[0] == 0)
                  {
                    printf("%02i\n", j);
                  }
              }
            exit(0);
          }
        fprintf(stderr, "Invalid parameter %s\n", argv[1]);
        exit(1);
        break;

      case 4:
        target = get_rc_target_nr(argv[1]);
        switch(target)
          {
            case RT_ROLE:
              tid.role = strtol(argv[2],0,10);
              break;
            case RT_TYPE:
              tid.type = strtol(argv[2],0,10);
              break;
            default:
              fprintf(stderr, "Invalid target %s\n", argv[1]);
              exit(1);
           }
        item = get_rc_item_nr(argv[3]);
        if(item == RI_none)
          {
            fprintf(stderr, "Invalid item %s\n", argv[3]);
            exit(1);
          }
        value.dummy = -1;
        res = rsbac_rc_get_item(target, &tid, item, &value);
        error_exit(res);
        switch (item)
          {
            case RI_role_comp:
              printf("%s\n",u64tostrrc(tmp1,value.role_comp));
              break;
            case RI_type_comp_fd:
            case RI_type_comp_dev:
            case RI_type_comp_process:
            case RI_type_comp_ipc:
            case RI_type_comp_scd:
              printf("%s\n",u64tostrlog(tmp1,value.type_comp[0]));
              break;
            case RI_name:
            case RI_type_fd_name:
            case RI_type_dev_name:
            case RI_type_ipc_name:
            case RI_type_process_name:
            case RI_type_scd_name:
              printf("%s\n",value.name);
              break;
            case RI_admin_type:
              printf("%u\n",value.admin_type);
              break;
            default:
              printf("%u\n",value.u_char_dummy);
          }
        exit(0);
        break;

      case 5:
        target = get_rc_target_nr(argv[1]);
        switch(target)
          {
            case RT_ROLE:
              tid.role = strtol(argv[2],0,10);
              break;
            case RT_TYPE:
              tid.type = strtol(argv[2],0,10);
              break;
            default:
              fprintf(stderr, "Invalid target %s\n", argv[1]);
              exit(1);
           }
        item = get_rc_item_nr(argv[3]);
        if(item == RI_none)
          {
            fprintf(stderr, "Invalid item %s\n", argv[3]);
            exit(1);
          }
        comp_type = strtol(argv[4],0,0);
        if(comp_type > RSBAC_RC_MAX_TYPE)
          {
            fprintf(stderr, "Invalid comp_type %s\n", argv[3]);
            exit(1);
          }
        value.dummy = -1;
        res = rsbac_rc_get_item(target, &tid, item, &value);
        error_exit(res);
        switch (item)
          {
            case RI_role_comp:
              if(value.role_comp & ((rsbac_rc_role_vector_t) 1 << comp_type))
                printf("1\n");
              else
                printf("0\n");
              break;
            case RI_type_comp_fd:
            case RI_type_comp_dev:
            case RI_type_comp_process:
            case RI_type_comp_ipc:
            case RI_type_comp_scd:
              printf("%s\n",u64tostrlog(tmp1,value.type_comp[comp_type]));
              break;
            case RI_name:
            case RI_type_fd_name:
            case RI_type_dev_name:
            case RI_type_ipc_name:
            case RI_type_process_name:
            case RI_type_scd_name:
              printf("%s\n",value.name);
              break;
            case RI_admin_type:
              printf("%u\n",value.admin_type);
              break;
            default:
              printf("%u\n",value.u_char_dummy);
          }
        exit(0);
        break;

      case 6:
        target = get_rc_target_nr(argv[1]);
        switch(target)
          {
            case RT_ROLE:
              tid.role = strtol(argv[2],0,10);
              break;
            case RT_TYPE:
              tid.type = strtol(argv[2],0,10);
              break;
            default:
              fprintf(stderr, "Invalid target %s\n", argv[1]);
              exit(1);
          }
        item = get_rc_item_nr(argv[3]);
        switch (item)
          {
            case RI_role_comp:
            case RI_type_comp_fd:
            case RI_type_comp_dev:
            case RI_type_comp_process:
            case RI_type_comp_ipc:
            case RI_type_comp_scd:
              break;
            default:
              fprintf(stderr, "Invalid item-position combination %s\n", argv[3]);
              exit(1);
          }
        comp_type = strtol(argv[4],0,10);
        if(   (comp_type < 0)
           || (   (target == RT_ROLE)
               && (comp_type > RSBAC_RC_MAX_ROLE)
              )
           || (   (target == RT_TYPE)
               && (comp_type > RSBAC_RC_MAX_TYPE)
              )
          )
          {
            fprintf(stderr, "Invalid comp_type %s\n", argv[4]);
            exit(1);
          }
        request = get_request_nr(argv[5]);
        if(request == R_NONE)
          {
            request = strtol(argv[5],0,10);
            if(   (request >= R_NONE)
               || (   (request == 0)
                   && strcmp(argv[5],"0")
                  )
              )
              {
                fprintf(stderr, "Invalid request %s\n", argv[4]);
                exit(1);
              }
          }

        value.dummy = -1;
        res = rsbac_rc_get_item(target, &tid, item, &value);
        error_exit(res);
        switch (item)
          {
            case RI_role_comp:
              if(value.role_comp & ((rsbac_rc_role_vector_t) 1 << comp_type))
                printf("1\n");
              else
                printf("0\n");
              break;
            case RI_type_comp_fd:
            case RI_type_comp_dev:
            case RI_type_comp_process:
            case RI_type_comp_ipc:
            case RI_type_comp_scd:
              if(value.type_comp[comp_type] & ((rsbac_rc_type_vector_t) 1 << request))
                printf("1\n");
              else
                printf("0\n");
              break;
            default:
              printf("ERROR!");
          }
        exit(0);
        break;

      default:
        printf("%s (RSBAC %s)\n***\n", progname, VERSION);
        printf("Use: %s rc-target-type id-nr item [comp-type [request]]\n", progname);  
        printf("     %s list_xxx\n", progname);  
        printf("     %s list_used_xxx\n", progname);  
        printf("- rc-target-type = ROLE or TYPE,\n");
        printf("- id-nr = ROLE or TYPE number,\n");
        printf("- item = entry line,\n");
        printf("- comp-type = for this type only (type_comp items only),\n");
        printf("- request = request number (type_comp items only),\n");
        printf("- xxx = roles, fd_types, dev_types, ipc_types, process_types, scd_types:\n");
        printf("-       role_nr, fd_type_nr, dev_type_nr, ipc_type_nr, process_type_nr,\n");
        printf("-       scd_type_nr, list_unused_role_nr, list_unused_fd_type_nr,\n");
        printf("-       list_unused_dev_type_nr, list_unused_ipc_type_nr,\n");
        printf("-       list_unused_process_type_nr: print a list,\n");
        printf("- item (string) and returned value = see following list:\n");
        printf("- ROLE:\n");
        for (j=0;j<RSBAC_RC_NR_ROLE_ENTRY_ITEMS;j++)
          {
            get_rc_item_name(tmp1,role_entry_item_list[j]);
            get_rc_item_param(tmp2,role_entry_item_list[j]);
            printf("%s \t%s\n",tmp1,tmp2);
          }
        printf("- TYPE:\n");
        for (j=0;j<RSBAC_RC_NR_TYPE_ENTRY_ITEMS;j++)
          {
            get_rc_item_name(tmp1,type_entry_item_list[j]);
            get_rc_item_param(tmp2,type_entry_item_list[j]);
            printf("%s \t%s\n",tmp1,tmp2);
          }
    }
  exit(1);
}
